require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_COMPLEX_H)) {
    eval 'sub _COMPLEX_H () {1;}' unless defined(&_COMPLEX_H);
    eval 'sub __GLIBC_INTERNAL_STARTING_HEADER_IMPLEMENTATION () {1;}' unless defined(&__GLIBC_INTERNAL_STARTING_HEADER_IMPLEMENTATION);
    require 'bits/libc-header-start.ph';
    require 'bits/mathdef.ph';
    require 'bits/floatn.ph';
    if( &__GNUC_PREREQ (2, 7)  && ! &__GNUC_PREREQ (2, 97)) {
	eval 'sub _Complex () { &__complex__;}' unless defined(&_Complex);
    }
    eval 'sub complex () { &_Complex;}' unless defined(&complex);
    eval 'sub _Complex_I () {( &__extension__ 1.0 &iF);}' unless defined(&_Complex_I);
    undef(&I) if defined(&I);
    eval 'sub I () { &_Complex_I;}' unless defined(&I);
    if(defined (&__USE_ISOC11)  &&  &__GNUC_PREREQ (4, 7)) {
	eval 'sub CMPLX {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex ( , ($y)));
	}' unless defined(&CMPLX);
	eval 'sub CMPLXF {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex ( , ($y)));
	}' unless defined(&CMPLXF);
	eval 'sub CMPLXL {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex ( , ($y)));
	}' unless defined(&CMPLXL);
    }
    if((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub CMPLXF16 {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex (( &_Float16) ($x), ( &_Float16) ($y)));
	}' unless defined(&CMPLXF16);
    }
    if((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub CMPLXF32 {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex (( &_Float32) ($x), ( &_Float32) ($y)));
	}' unless defined(&CMPLXF32);
    }
    if((defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub CMPLXF64 {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex (( &_Float64) ($x), ( &_Float64) ($y)));
	}' unless defined(&CMPLXF64);
    }
    if((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub CMPLXF128 {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex (( &_Float128) ($x), ( &_Float128) ($y)));
	}' unless defined(&CMPLXF128);
    }
    if((defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub CMPLXF32X {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex (( &_Float32x) ($x), ( &_Float32x) ($y)));
	}' unless defined(&CMPLXF32X);
    }
    if((defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub CMPLXF64X {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex (( &_Float64x) ($x), ( &_Float64x) ($y)));
	}' unless defined(&CMPLXF64X);
    }
    if((defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub CMPLXF128X {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex (( &_Float128x) ($x), ( &_Float128x) ($y)));
	}' unless defined(&CMPLXF128X);
    }
    eval 'sub __MATHCALL {
        my($function, $args) = @_;
	    eval q( &__MATHDECL ( &_Mdouble_complex_,$function, $args));
    }' unless defined(&__MATHCALL);
    eval 'sub __MATHDECL {
        my($type, $function, $args) = @_;
	    eval q( &__MATHDECL_1($type, $function, $args);  &__MATHDECL_1($type,  &__CONCAT( &__,$function), $args));
    }' unless defined(&__MATHDECL);
    eval 'sub __MATHDECL_1 {
        my($type, $function, $args) = @_;
	    eval q( &extern $type  &__MATH_PRECNAME($function) $args  &__THROW);
    }' unless defined(&__MATHDECL_1);
    eval 'sub _Mdouble_ () {\'double\';}' unless defined(&_Mdouble_);
    eval 'sub __MATH_PRECNAME {
        my($name) = @_;
	    eval q($name);
    }' unless defined(&__MATH_PRECNAME);
    require 'bits/cmathcalls.ph';
    undef(&_Mdouble_) if defined(&_Mdouble_);
    undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
    eval 'sub _Mdouble_ () {\'float\';}' unless defined(&_Mdouble_);
    eval 'sub __MATH_PRECNAME {
        my($name) = @_;
	    eval q($name &f);
    }' unless defined(&__MATH_PRECNAME);
    require 'bits/cmathcalls.ph';
    undef(&_Mdouble_) if defined(&_Mdouble_);
    undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
    if(!(defined (&__NO_LONG_DOUBLE_MATH)  && defined (&_LIBC)) || defined (&__LDBL_COMPAT)) {
	if(defined(&__LDBL_COMPAT)) {
	    undef(&__MATHDECL_1) if defined(&__MATHDECL_1);
	    eval 'sub __MATHDECL_1 {
	        my($type, $function, $args) = @_;
    		eval q( &extern $type  &__REDIRECT_NTH( &__MATH_PRECNAME($function), $args, $function));
	    }' unless defined(&__MATHDECL_1);
	}
	eval 'sub _Mdouble_ () {\'long double\';}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name) = @_;
    	    eval q($name &l);
	}' unless defined(&__MATH_PRECNAME);
	require 'bits/cmathcalls.ph';
    }
    undef(&_Mdouble_) if defined(&_Mdouble_);
    undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
    if(((defined(&__HAVE_DISTINCT_FLOAT16) ? &__HAVE_DISTINCT_FLOAT16 : undef) || ((defined(&__HAVE_FLOAT16) ? &__HAVE_FLOAT16 : undef)  && !defined (&_LIBC)))  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_complex_ () { &__CFLOAT16;}' unless defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_ () { &_Float16;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name) = @_;
    	    eval q($name &f16);
	}' unless defined(&__MATH_PRECNAME);
	require 'bits/cmathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
    }
    if(((defined(&__HAVE_DISTINCT_FLOAT32) ? &__HAVE_DISTINCT_FLOAT32 : undef) || ((defined(&__HAVE_FLOAT32) ? &__HAVE_FLOAT32 : undef)  && !defined (&_LIBC)))  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_complex_ () { &__CFLOAT32;}' unless defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_ () { &_Float32;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name) = @_;
    	    eval q($name &f32);
	}' unless defined(&__MATH_PRECNAME);
	require 'bits/cmathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
    }
    if(((defined(&__HAVE_DISTINCT_FLOAT64) ? &__HAVE_DISTINCT_FLOAT64 : undef) || ((defined(&__HAVE_FLOAT64) ? &__HAVE_FLOAT64 : undef)  && !defined (&_LIBC)))  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_complex_ () { &__CFLOAT64;}' unless defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_ () { &_Float64;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name) = @_;
    	    eval q($name &f64);
	}' unless defined(&__MATH_PRECNAME);
	require 'bits/cmathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
    }
    if(((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef) || ((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  && !defined (&_LIBC)))  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_complex_ () { &__CFLOAT128;}' unless defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_ () { &_Float128;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name) = @_;
    	    eval q($name &f128);
	}' unless defined(&__MATH_PRECNAME);
	require 'bits/cmathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
    }
    if(((defined(&__HAVE_DISTINCT_FLOAT32X) ? &__HAVE_DISTINCT_FLOAT32X : undef) || ((defined(&__HAVE_FLOAT32X) ? &__HAVE_FLOAT32X : undef)  && !defined (&_LIBC)))  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_complex_ () { &__CFLOAT32X;}' unless defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_ () { &_Float32x;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name) = @_;
    	    eval q($name &f32x);
	}' unless defined(&__MATH_PRECNAME);
	require 'bits/cmathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
    }
    if(((defined(&__HAVE_DISTINCT_FLOAT64X) ? &__HAVE_DISTINCT_FLOAT64X : undef) || ((defined(&__HAVE_FLOAT64X) ? &__HAVE_FLOAT64X : undef)  && !defined (&_LIBC)))  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_complex_ () { &__CFLOAT64X;}' unless defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_ () { &_Float64x;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name) = @_;
    	    eval q($name &f64x);
	}' unless defined(&__MATH_PRECNAME);
	require 'bits/cmathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
    }
    if(((defined(&__HAVE_DISTINCT_FLOAT128X) ? &__HAVE_DISTINCT_FLOAT128X : undef) || ((defined(&__HAVE_FLOAT128X) ? &__HAVE_FLOAT128X : undef)  && !defined (&_LIBC)))  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_complex_ () { &__CFLOAT128X;}' unless defined(&_Mdouble_complex_);
	eval 'sub _Mdouble_ () { &_Float128x;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name) = @_;
    	    eval q($name &f128x);
	}' unless defined(&__MATH_PRECNAME);
	require 'bits/cmathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
    }
    undef(&__MATHDECL_1) if defined(&__MATHDECL_1);
    undef(&__MATHDECL) if defined(&__MATHDECL);
    undef(&__MATHCALL) if defined(&__MATHCALL);
}
1;
